{%- block submission -%}
  {%- from '_macros/icon.html.twig' import icon -%}
  {%- from '_macros/time.html.twig' import relative_time, relative_time_diff -%}
  {%- from 'vote/_macros.html.twig' import vote -%}
  {%- set open_external = submission.url is not empty and open_external_links_in_new_tab -%}
  {%- set has_thumbnail = submission.image and show_thumbnails and not
    (show_body and submission.mediaType is constant('App\\Entity\\Submission::MEDIA_IMAGE')) -%}
  <article class="{{ block('submission_classes') }}">
    <div class="submission__row">

      <div class="submission__inner">
        <header class="submission__header">
          <h1 class="submission__title break-text">
            <a href="{{ block('submission_url') }}"
               class="submission__link"
               rel="{{ submission.url ? 'nofollow noreferrer noopener' }}"
               target="{{ open_external ? '_blank' : '_self' }}">
              {%- if has_thumbnail -%}
                <img src="{{ submission.image|imagine_filter('submission_thumbnail_1x') }}"
                     srcset="{{ submission.image|imagine_filter('submission_thumbnail_2x') }} 2x"
                     class="submission__thumb"
                     alt=""
                     width="70"
                     height="70"
                     aria-hidden="true">
              {%- endif -%}

              {%- if raw_title is not null -%}
                {{ raw_title|raw }}
              {%- elseif submission.visibility == constant('App\\Entity\\Submission::VISIBILITY_DELETED') -%}
                <del>{{ 'placeholder.deleted'|trans }}</del>
              {%- else -%}
                {{ submission.title }}
              {%- endif -%}
            </a>

            {% if submission.sticky %}
              <span class="submission__sticky-icon"
                    title="{{ 'This submission is pinned'|trans }}">
                {{- icon('pin') -}}
              </span>
            {% endif %}

            {% if submission.locked %}
              <span class="submission__locked-icon"
                    title="{{ 'This submission is locked'|trans }}">
                {{- icon('lock') -}}
              </span>
            {% endif %}

            {% if submission.url is not empty and '://' in submission.url %}
              {% with { host: submission.url|split('://')[1]|split('/')[0] } %}
                <a href="{{ path('search', { q: host }) }}" class="submission__host text-xs">
                  {{- host[0:4] == 'www.' ? host[4:] : host -}}
                </a>
              {%- endwith -%}
            {% endif %}
          </h1>

          <p class="submission__info">
            <span class="text-sm fg-muted">
              {{ (show_forum_name ? 'submissions.info_with_forum_name' : 'submissions.info_without_forum_name')|trans({
                '%submitter%': block('submission_info_submitter'),
                '%timestamp%': relative_time(submission.timestamp, {
                  natural: true,
                  extra_classes: 'submission__timestamp',
                }),
                '%forum%': block('submission_info_forum_name'),
              })|raw }}

              {% if submission.editedAt %}
                <span class="submission__info-edited-at {{ submission.moderated ? 'submission__info-moderated' }}">
                  {{ (submission.moderated ? 'submissions.moderator_info' : 'submissions.edit_info')|trans({
                    '%edited_at%': relative_time_diff(submission.editedAt, submission.timestamp, { natural: true })
                  })|raw }}
                </span>
              {% endif %}
            </span>
          </p>
        </header>

        {%- if show_body -%}
          {% if raw_body is not null or submission.body is not null %}
            <div class="submission__body break-text">
              {%- if raw_body is not null -%}
                {{ raw_body|raw }}
              {%- elseif submission.body is not null -%}
                {{ submission.body|cached_markdown({ context: 'submission', submission: submission })|raw }}
              {%- endif -%}
            </div>
          {% endif %}

          {% if submission.mediaType is constant('App\\Entity\\Submission::MEDIA_IMAGE') and submission.image %}
            <a href="{{ upload_url('submission_images/'~submission.image) }}"
               class="submission__image-link"
               target="{{ open_external ? '_blank' : '_self' }}">
              <img src="{{ upload_url('submission_images/'~submission.image) }}" alt="" class="submission__image">
            </a>
          {% endif %}
        {%- endif -%}

        <nav class="submission__nav">
          <ul class="unlistify fg-muted nav nav--guttered no-margin">
            {{ block('submission_nav') }}
          </ul>
        </nav>
      </div>

      <div class="submission__vote">
        {{- vote(submission, 'submission_vote') -}}
      </div>
    </div>
  </article>
{% endblock submission %}

{%- block submission_url -%}
  {%- if submission.url -%}
    {{- submission.url -}}
  {%- elseif submission.mediaType is constant('App\\Entity\\Submission::MEDIA_IMAGE') and submission.image -%}
    {{- upload_url('submission_images/'~submission.image) -}}
  {%- else -%}
    {{- path('submission', { forum_name: submission.forum.name, submission_id: submission.id, slug: submission.title|slugify }) -}}
  {%- endif -%}
{%- endblock submission_url -%}

{% block submission_classes %}
  submission
  {{ submission.url ? 'submission--has-url' }}
  {{ submission.body is not null ? 'submission--has-body' }}
  {{ not show_body ? 'submission--collapsed' : 'submission--expanded' }}
  {{ submission.sticky ? 'submission--sticky' }}
  {{ submission.locked ? 'submission--locked' }}
  {{ has_thumbnail ? 'submission--has-thumbnail' }}
  submission--visibility-{{ submission.visibility }}
{% endblock submission_classes %}

{% block submission_info_submitter %}
  {% from 'user/_macros.html.twig' import user_flag %}
  {% if submission.visibility != constant('App\\Entity\\Submission::VISIBILITY_DELETED') %}
    {% apply spaceless %}
      <a href="{{ path('user', { username: submission.user.username }) }}" class="submission__submitter fg-inherit">
        <strong>{{ submission.user.username }}</strong>
      </a>
    {% endapply %}
    {{ user_flag(submission.userFlag) }}
  {% else %}
    {{ 'placeholder.deleted'|trans }}
  {% endif %}
{% endblock submission_info_submitter %}

{% block submission_info_forum_name %}
  {% apply spaceless %}
    <a href="{{ path('forum', { forum_name: submission.forum.name }) }}" class="submission__forum fg-inherit">
      <strong>{{ submission.forum.name }}</strong>
    </a>
  {% endapply %}
{% endblock submission_info_forum_name %}

{% block submission_nav %}
  {% set nav_link_classes = 'fg-inherit text-sm' %}
  {{ block('submission_nav_comments') }}
  {% if submission.user is same as(self) %}
    {{ block('submission_nav_edit') }}
  {% endif %}
  {{ block('submission_nav_delete_own') }}
  {{ block('submission_nav_actions') }}
{% endblock submission_nav %}

{% block submission_nav_comments %}
  <li>
    {% apply spaceless %}
      <a href="{{ path('submission', { forum_name: submission.forum.name, submission_id: submission.id, slug: submission.title|slugify }) }}"
         class="text-sm">
        <strong>{{ 'submissions.comments'|trans({ '%count%': submission.commentCount }) }}</strong>
      </a>
    {% endapply %}

    {%- if not show_body -%}
      <span class="js-display-new-comments submission__new-comments text-sm fg-green"
            data-submission-id="{{ submission.id }}"
            data-comment-count="{{ submission.commentCount }}">
      </span>
    {%- endif -%}
  </li>
{% endblock submission_nav_comments %}

{% block submission_nav_actions %}
  {% set nav_link_classes = 'menu-item no-wrap' %}

  {% set actions %}
    {% if submission.user is not same as(self) %}
      {{ block('submission_nav_edit') }}
    {% endif %}
    {{ block('submission_nav_mod_delete') }}
    {{ block('submission_nav_purge') }}
    {{ block('submission_nav_pin') }}
    {{ block('submission_nav_lock') }}
    {{ block('submission_nav_ban') }}
    {{ block('submission_nav_global_ban') }}
  {% endset %}

  {% if actions|trim is not empty %}
    <li class="dropdown">
      <button class="dropdown__toggle fg-inherit text-sm unbuttonize no-underline" type="button">
        <span class="no-underline__exempt">{{ 'nav.actions'|trans }}</span>
        <span class="dropdown__arrow" aria-hidden="true"></span>
      </button>
      <ul class="dropdown-card dropdown__menu no-margin unlistify">
        {{ actions }}
      </ul>
    </li>
  {% endif %}
{% endblock submission_nav_actions %}

{% block submission_nav_edit %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('edit', submission) %}
    <li>
      <a href="{{ path('edit_submission', {forum_name: submission.forum.name, submission_id: submission.id}) }}"
         class="{{ nav_link_classes }}">
        {{- 'menu-item' in nav_link_classes ? icon('pencil') }}
        {{ 'submissions.edit'|trans -}}
      </a>
    </li>
  {% endif %}
{% endblock submission_nav_edit %}

{% block submission_nav_delete_own %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('delete_own', submission) %}
    <li>
      <form action="{{ path('submission_delete_own', { forum_name: submission.forum.name, submission_id: submission.id }) }}" method="POST">
        <input type="hidden" name="token" value="{{ csrf_token('delete_submission') }}">
        <button class="{{ nav_link_classes }} unbuttonize js-confirm-submission-delete">
          {{- 'menu-item' in nav_link_classes ? icon('trash') }}
          {{ 'action.delete'|trans -}}
        </button>
      </form>
    </li>
  {% endif %}
{% endblock submission_nav_delete_own %}

{% block submission_nav_mod_delete %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('mod_delete', submission) %}
    <li>
      <a href="{{ path('submission_mod_delete', { forum_name: submission.forum.name, submission_id: submission.id }) }}"
         class="{{ nav_link_classes }}">
        {{- 'menu-item' in nav_link_classes ? icon('trash') }}
        {{ mod_delete_label ?? 'action.delete'|trans -}}
      </a>
    </li>
  {% endif %}
{% endblock submission_nav_mod_delete %}

{% block submission_nav_purge %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('purge', submission) %}
    <li>
      <a href="{{ path('submission_purge', { forum_name: submission.forum.name, submission_id: submission.id }) }}"
         class="unbuttonize menu-item no-wrap">
        {{- icon('cancel') }}
        {{ 'action.purge'|trans -}}
      </a>
    </li>
  {% endif %}
{% endblock submission_nav_purge %}

{% block submission_nav_pin %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('pin', submission) %}
    <li>
      <form action="{{ path(submission.sticky ? 'unpin' : 'pin', {
        forum_name: submission.forum.name,
        submission_id: submission.id,
      }) }}" method="post">
        <input type="hidden" name="token" value="{{ csrf_token('pin') }}">
        <button class="unbuttonize menu-item no-wrap">
          {{- submission.sticky ? icon('pin-outline') : icon('pin') }}
          {{ submission.sticky ? 'action.unpin'|trans : 'action.pin'|trans -}}
        </button>
      </form>
    </li>
  {% endif %}
{% endblock submission_nav_pin %}

{% block submission_nav_lock %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('lock', submission) %}
    <li>
      <form action="{{ path(submission.locked ? 'unlock' : 'lock', {
        forum_name: submission.forum.name,
        submission_id: submission.id,
      }) }}" method="post">
        <input type="hidden" name="token" value="{{ csrf_token('lock') }}">
        <button class="unbuttonize menu-item no-wrap">
          {{- submission.locked ? icon('lock-open') : icon('lock') }}
          {{ submission.locked ? 'action.unlock'|trans : 'action.lock'|trans -}}
        </button>
      </form>
    </li>
  {% endif %}
{% endblock submission_nav_lock %}

{% block submission_nav_ban %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('moderator', submission.forum) %}
    <li>
      <a href="{{ path('forum_ban', { forum_name: submission.forum.name, username: submission.user.username }) }}"
         class="menu-item no-wrap">
        {{- icon('user-times') }}
        {{ 'action.ban'|trans -}}
      </a>
    </li>
  {% endif %}
{% endblock submission_nav_ban %}

{% block submission_nav_global_ban %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('ROLE_ADMIN') %}
    <li>
      <a href="{{ path('ban_user', { username: submission.user.username }) }}"
         class="menu-item no-wrap">
        {{- icon('hammer') }}
        {{ 'action.global_ban'|trans -}}
      </a>
    </li>
  {% endif %}
{% endblock submission_nav_global_ban %}
